package vishnu.cluster;

class TriangleIndex
{
	short [] i_ind;    /* from index to i */
	short [] j_ind;    /* from index to j */



	TriangleIndex(int matrix_rows)
	{

  		short i, j;
        int theIndex;

  		int num_of_elements = matrix_rows * (matrix_rows - 1) / 2;

  		/* Allocate space for lookup tables */
  		i_ind = new short[num_of_elements];
  		j_ind = new short [num_of_elements];

	  	for (i = 1; i < matrix_rows; i++)
    	{
      		for (j = 0; j < i; j++)
			{
	  			theIndex = TriangleIndex.index (i, j);
				i_ind[theIndex] = i;
	  			j_ind[theIndex] = j;
			}
    	}
	}

	int row_size (int size)
	{
  /* Don't forget that we actually start counting in the second row, since the first one is assumed to be all zeroes */
  		int i = 1;
  		int sum = 0;

  		while (sum != size)
    		sum += i++;
  		return i;
	}

	static int index (int i, int j)
	{
  /* Assumes lower triangular matrix, i.e. i>j */

  		int temp;

  /* The matrix in this case is symmetric so (i, j) = (j, i) */
  		if (i < j)
    	{
      		temp = i; i = j; j = temp;
    	}

  		if (i != j)
    		return (i*i-i)/2 + j;
    		//(i - 1) * (i - 2) / 2 + i - 1 + j;
  		else         /* The elements on the diagonal are all 0 */
    	{
      		return -1; /* so just return the dummy value -1      */
    	}
	}
	static void print (double[] matrix, int row_size)
	{
  		int i, j, theIndex;

  		for (i = 0; i < row_size; i++)
    	{
      		for (j = 0; j < row_size; j++)
			{
	  			if (i <= j)
	    			System.out.print(" ");
	  			else
	    		{
	      			theIndex = index (i, j);
	      			System.out.print(matrix[theIndex] + " ");
	    		}
			}
      		System.out.println();
    	}
	}

}

